<template>
  <v-container>
    <v-row align="center" class="mt-4">
      <router-link class="site-name title-desktop" to="/dashboard">
        <v-icon size="32">mdi-checkbox-blank-circle-outline</v-icon>
      </router-link>
      <router-link class="site-name title-mobile" to="/dashboard">
        <v-icon>mdi-checkbox-blank-circle-outline</v-icon>
      </router-link>
      <v-spacer></v-spacer>
      <v-btn text small to="/circles" class="menu-extras" exact
        >Find a circle</v-btn
      >
      <v-btn text small to="/facilitators" class="menu-extras" exact
        >Book a facilitator</v-btn
      >
      <v-menu offset-y left bottom>
        <template v-slot:activator="{ on }">
          <v-btn icon v-on="on">
            <v-icon size="32">mdi-heart</v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item>
            <v-list-item-avatar>
              <v-avatar color="indigo" size="36">
                <span class="white--text headline">{{
                  user.firstName && user.firstName[0]
                }}</span>
              </v-avatar>
            </v-list-item-avatar>

            <v-list-item-content>
              <v-list-item-title
                >{{ user.firstName }} {{ user.lastName }}</v-list-item-title
              >
              <v-list-item-subtitle>{{ user.email }}</v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
          <v-list-item to="/dashboard">
            <v-list-item-title>Dashboard</v-list-item-title>
          </v-list-item>
          <v-list-item class="d-sm-none" to="/circles">
            <v-list-item-title>Find a circle</v-list-item-title>
          </v-list-item>
          <v-list-item class="d-sm-none" to="/facilitators">
            <v-list-item-title>Book a facilitator</v-list-item-title>
          </v-list-item>
          <v-list-item to="/account">
            <v-list-item-title>Account</v-list-item-title>
          </v-list-item>
          <v-list-item to="/notifications">
            <v-list-item-title>
              Notifications
              <span class="deep-purple--text accent-2 font-weight-bold ml-2 v-btn--absolute v-snack--top">Beta</span>
            </v-list-item-title>
          </v-list-item>
          <v-divider />
          <v-list-item @click="logout">
            <v-list-item-title>Sign Out</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-row>
  </v-container>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import { Role } from '@/constants'

export default {
  computed: {
    ...mapState('authentication', ['user'])
  },
  data: () => ({
    Role
  }),
  methods: {
    ...mapActions('authentication', ['logout'])
  }
}
</script>

<style lang="scss" scoped>
@import '@/sass/variables.scss';

.navbar {
  z-index: 9;
  a {
    display: flex;
    align-items: center;
  }

  .title-desktop {
    display: inline;
  }

  .title-mobile {
    display: none;
  }

  .site-name {
    font-size: 1.3rem;
    font-weight: 600;
    color: #2c3e50;
    position: relative;
  }

  .logo {
    height: 24px;
    padding-right: 8px;
  }

  .links {
    padding-left: 1.5rem;
    box-sizing: border-box;
    white-space: nowrap;
    font-size: 0.9rem;
    position: absolute;
    right: 1.5rem;
    top: 0.7rem;
    display: flex;

    .nav-links {
      display: flex;
      align-items: center;
      justify-content: center;

      .nav-item {
        position: relative;
        display: inline-block;
        margin-left: 1.5rem;
        line-height: 2.2rem;

        &:first-child {
          margin-left: 0;
        }

        a {
          font-weight: 500;
          font-size: 0.9rem;
          text-decoration: none;
          color: $navbar-link-color;
          border-color: #2c3e50;
          line-height: 1.4rem;
          display: inline-block;
          cursor: pointer;
        }

        @mixin activatedLink() {
          margin-bottom: -2px;
          border-bottom: 2px solid $vue-color;
        }

        .router-link-active {
          @include activatedLink;
        }

        @media (hover) {
          :hover {
            @include activatedLink;
          }
        }
      }
    }
  }

  &.offline {
    background: $navbar-offline-color;

    .links .nav-links .nav-item a,
    .site-name {
      color: white;
    }
  }

  .user-picture {
    max-height: 32px;
    margin-left: 1.5rem;
    border-radius: 50%;
  }

  .offline-label {
    padding: 0px 10px;
    border: 1px solid white;
    border-radius: 5px;
    color: white;
    margin-left: 1.5rem;
  }

  @media (max-width: 500px) {
    padding: 0.7rem 0.7rem;

    .can-hide {
      display: none;
    }

    .title-desktop {
      display: none;
    }

    .title-mobile {
      display: block;
    }
  }

  @media (max-width: 800px) {
    .menu-extras {
      display: none !important;
    }
  }
}
</style>
